/** fxtbook page 243. */

#include "perm.h"


void first_perm(int a[], int n) {
 int i;

 /*@ loop invariant 0 <= i <= n;
   @ loop invariant is_id(a,i);
   @ loop assigns i, a[0..n-1];
   @ loop variant n-i; */
 for (i = 0; i < n; i++) {
  a[i] = i;
 }
}

int next_perm(int a[], int n) {
 int i,j,tmp,s,r;
 i = n-2;
 
 // 1. find the rightmost i s.t. a[i] < a[i+1]:
 /*@ loop invariant -1 <= i <= n-2;
   @ loop assigns i; */
 while (i >= 0 && a[i] >= a[i+1]) { i--; }
 
 if (i < 0) { return 0; } // last sequence is falling seq.
 
 // 2. find rightmost (i.e. smallest) element a[j] more (not less) than a[i]:
 j = n-1;
 /*@ loop invariant i+1 <= j <= n-1;
   @ loop assigns j; */
 while (j > i+1 && a[i] >= a[j]) { j--; } 
                                          
 // 3. swap(p[i], p[j]):
 tmp = a[i]; 
 a[i] = a[j]; 
 a[j] = tmp; 
 
 // 4. Reverse order to the right: 
 s = i+1;
 r = n-1;
 
 /*@ loop invariant i+1 <= r <= n-1;
   @ loop invariant i+1 <= s <= n-1;
   @ loop invariant is_perm(a,n);
   @ loop assigns tmp,r,s,a[i+1..n-1]; */
 while (r >= 0 && n-1 >= s && r > s) { 
  tmp = a[r]; 
  a[r] = a[s]; 
  a[s] = tmp; 
  r--;
  s++;
 }

 return 1; 
}

