/* Generation algorithm for RGFs.
 Adaptation of the algorithm page 235 of the fxtbook. */
 
#include "rgf.h"
  
void first_rgf(int a[], int n) {
 int k;
 /*@ loop invariant 0 <= k <= n;
   @ loop invariant is_zero(a,0,k);
   @ loop assigns k, a[0..n-1];
   @ loop variant n-k; */
 for (k = 0; k < n; k++) { a[k] = 0; }
}

int next_rgf(int a[], int n) {
 int i,k;
 /*@ loop invariant 0 <= i <= n-1;
   @ loop assigns i;
   @ loop variant i; */
 for (i = n-1; i >= 1; i--)
  if (a[i] <= a[i-1]) { break; }
 if (i == 0) { return 0; } // Last RGF.
 a[i] = a[i] + 1;
 /*@ loop invariant i+1 <= k <= n;
   @ loop invariant is_non_neg(a,0,k);
   @ loop invariant is_le_pred(a,1,k);
   @ loop assigns k, a[i+1..n-1];
   @ loop variant n-k; */
 for (k = i+1; k < n; k++) { a[k] = 0; }
 return 1;
}
