#include "../../global.h"

/*@ predicate is_non_neg(int *a, integer b, integer c) = \forall integer i; b <= i < c ==> a[i] >= 0;
  @ predicate is_le_pred(int *a, integer b, integer c) = \forall integer i; b <= i < c ==> a[i] <= a[i-1]+1;
  @ predicate is_rgf(int *a, integer n) = a[0] == 0 && is_non_neg(a,0,n) && is_le_pred(a,1,n);
  @ predicate is_zero(int *a, integer b, integer c) = \forall integer i; b <= i < c ==> a[i] == 0; */

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures is_rgf(a,n); */
void first_rgf(int a[], int n);

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_rgf(a,n);
  @ assigns a[1..n-1];
  @ ensures is_rgf(a,n);
  @ ensures \result == 0 ==> is_eq{Pre,Post}(a,n);
  @ ensures \result == 1 ==> lt_lex{Pre,Post}(a,n); */
int next_rgf(int a[], int n);
