/* Generation of all permutations on [0..n-1], tabulated in an array [0..n-1]
 * in the increasing lexicographic order induced by the precedence order < on
 * integers. Here, by filtering among all endofunctions on [0..n-1] which are
 * not injections. */

#include "injEndo.h"
     
/** Returns 1 when the array a is an injection, and 0 otherwise. */
int b_injEndo(int a[], int n) {
 return (b_linear(a,n));
}


int first_injEndo(int a[], int n) {
 int tmp;
  
 tmp = first_endofct(a,n);
 if (tmp != 1) { return 0; }
 
 /*@ loop invariant tmp != 0 ==> is_endofct(a,n);
   @ loop assigns a[0..n-1],tmp; */
 while (tmp != 0 && b_injEndo(a,n) == 0) {
  tmp = next_endofct(a,n);
 } 
 
 if (tmp == 0) { return 0; }
 return 1;
}
 
int next_injEndo(int a[], int n) {
 int tmp;
 
 /*@ loop invariant is_endofct(a,n);
   @ loop assigns a[0..n-1],tmp;
   @ loop invariant le_lex{Pre,Here}(a,n); */ 
 do {
  tmp = next_endofct(a,n);
 } while (tmp != 0 && b_injEndo(a,n) == 0);

 if (tmp == 0) { return 0; }
 return 1;
}

