/* Generation of all permutations on [0..n-1], tabulated in an array [0..n-1]
 * in the increasing lexicographic order induced by the precedence order < on
 * integers. Here, by filtering of endofunctions on [0..n-1] which are
 * surjections.
 *
 * File generated by instantiation of the patterns allex.c and rejection.c.
 */

#include "surjEndo.h"

int b_x3(int a[], int n, int n1, int n2) {
 return(a[n2] == n1);
}

int b_eq_im(int a[], int n, int n1) {
 int i;

 /*@ loop invariant 0 <= i <= n;
   @ loop invariant ! is_eq_im_gen(a,n,n1,i);
   @ loop assigns i;
   @ loop variant n-i;*/
 for (i = 0; i < n; i++)
  if (b_x3(a,n,n1,i) == 1) return 1;
 return 0;
}

int b_im(int a[], int n) {
 int i;

 /*@ loop invariant 0 <= i <= n;
   @ loop invariant is_im_gen(a,n,i);
   @ loop assigns i;
   @ loop variant n-i;*/
 for (i = 0; i < n; i++)
  if (b_eq_im(a,n,i) == 0) return 0;
 return 1;
}

/* Returns 1 when the array a is a surjection, and 0 otherwise. */
int b_surjEndo(int a[], int n) {
 return (b_im(a,n));
}


int first_surjEndo(int a[], int n) {
 int tmp;
 
 tmp = first_endofct(a,n);
 /*@ loop invariant tmp != 0 ==> is_endofct(a,n);
   @ loop assigns a[0..n-1],tmp; */
 while (tmp != 0 && b_surjEndo(a,n) == 0) {
  tmp = next_endofct(a,n);
 } 
 if (tmp == 0) { return 0; }
 return 1;
}

int next_surjEndo(int a[], int n) {
 int tmp;
 
 /*@ loop invariant is_endofct(a,n);
   @ loop assigns a[0..n-1],tmp;
   @ loop invariant le_lex{Pre,Here}(a,n); */
 do {
  tmp = next_endofct(a,n);
 } while (tmp != 0 && b_surjEndo(a,n) == 0);
 if (tmp == 0) { return 0; }
 return 1;
}
