/* Generation of all surjections from [0..n-1] to [0..k-1], tabulated in an array
 * [0..n-1] containing values between 0 and k-1, in the increasing lexicographic 
 * order induced by the precedence order < on integers.
 * Here, by filtering among all functions from [0..n-1] to [0..k-1].
 *
 * File generated by instantiation of the patterns allex.c and rejection.c.
 */

#include "surj.h"
  
int b_x3(int a[], int n, int k, int n1, int n2) {
 return(a[n2] == n1);
}

int b_eq_im(int a[], int n, int k, int n1) {
 int i;

 /*@ loop invariant 0 <= i <= n;
   @ loop invariant ! is_eq_im_gen(a,n,k,n1,i);
   @ loop assigns i;
   @ loop variant n-i;*/
 for (i = 0; i < n; i++)
  if (b_x3(a,n,k,n1,i) == 1) return 1;
 return 0;
}

int b_im(int a[], int n, int k) {
 int i;

 /*@ loop invariant 0 <= i <= k;
   @ loop invariant is_im_gen(a,n,k,i);
   @ loop assigns i;
   @ loop variant k-i;*/
 for (i = 0; i < k; i++)
  if (b_eq_im(a,n,k,i) == 0) return 0;
 return 1;
}

/* Returns 1 when the array a is a surjection, and 0 otherwise. */
int b_surj(int a[], int n, int k) {
 return (b_im(a,n,k));
}


int first_surj(int a[], int n, int k) {
 int tmp;
 
 tmp = first_fct(a,n,k);
 /*@ loop invariant tmp != 0 ==> is_fct(a,n,k);
   @ loop assigns a[0..n-1],tmp; */
 while (tmp != 0 && b_surj(a,n,k) == 0) {
  tmp = next_fct(a,n,k);
 } 
 if (tmp == 0) { return 0; }
 return 1;
}


int next_surj(int a[], int n, int k) {
 int tmp;
 
 /*@ loop invariant is_fct(a,n,k);
   @ loop assigns a[0..n-1],tmp;
   @ loop invariant le_lex{Pre,Here}(a,n); */
 do {
  tmp = next_fct(a,n,k);
 } while (tmp != 0 && b_surj(a,n,k) == 0);
 if (tmp == 0) { return 0; }
 return 1;
}
